Bug 785026

Summary: Event logging is broken with no feedback to the user if native support is disabled
Product: [Other] RHQ Project Reporter: Larry O'Leary <loleary>
Component: EventsAssignee: Charles Crouch <ccrouch>
Status: CLOSED CURRENTRELEASE QA Contact: Mike Foley <mfoley>
Severity: medium Docs Contact:
Priority: high    
Version: 4.2CC: ccrouch, hbrock, hrupp, skondkar, spinder
Target Milestone: ---   
Target Release: JON 3.0.1   
Hardware: All   
OS: All   
URL: https://fedorahosted.org/pipermail/rhq-devel/2012-January/001434.html
See Also: https://bugzilla.redhat.com/show_bug.cgi?id=773435
Whiteboard:
Fixed In Version: 4.3 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 785802 (view as bug list) Environment:
Last Closed: 2013-09-03 11:19:10 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On:    
Bug Blocks: 785802, 782579    
Attachments:
Description Flags
agent log ... (which does not show the WARN as expected) none

Description Larry O'Leary 2012-01-26 19:03:20 EST
Description of problem:
If event logging is enabled but native support is disabled, events do not get processed.

A pure Java alternative should be provided in cases where native support is unavailable or the user should be warned that although event logging is enabled for a resource, it will not be active due to native support being disabled.

Version-Release number of selected component (if applicable):
4.3

How reproducible:
Always

Steps to Reproduce:
1. Enable event logging for an AS resource or RHQ Agent
2. Confirm events are being logged
3. Restart agent with the --nonative command-line option
  
Actual results:
No events are logged once the agent is started with --nonative and the agent log contains no information indicating that event logging is failing

Expected results:
Event logging should continue to work

Additional info:
Ian's response from rhq-devel https://fedorahosted.org/pipermail/rhq-devel/2012-January/001434.html confirms this issue exists and suggests that it might be possible to implement a pure Java option.
Comment 1 Ian Springer 2012-01-27 10:00:28 EST
Raising the sev on this to medium. We really should be logging a warning. It would also be nice if we threw an exception in the plugins if a user tried to enable log events when native support is disabled in the Agent.

But I think getting log events to work w/out SIGAR is low priority, since we support SIGAR on all the major platforms.
Comment 2 Mike Foley 2012-01-30 11:37:01 EST
per 12/30/2012 BZ triage meeting mfoley, ccrouch, loleary, asantos

we are splitting this BZ into 2 ...

1) we are reducing the scope of this BZ.  providing customer feedback *is* the new reduced scope of this BZ ... and this is being targetted for 3.01.

2) i will be cloning a 2nd BZ as an RFE for the pure java alternative
Comment 3 Mike Foley 2012-01-30 11:40:00 EST
the RFE for the pure java alternative to Sigar is --->>>  https://bugzilla.redhat.com/show_bug.cgi?id=785802
Comment 6 Charles Crouch 2012-01-30 23:36:49 EST
Switching to using MODIFIED for fixes that are in the appropriate but are waiting to get into a build.
Comment 7 Ian Springer 2012-01-31 12:27:08 EST
This is now also fixed in master - http://git.fedorahosted.org/git/?p=rhq/rhq.git;a=commitdiff;h=5b7557b.

QE, you can test this as follows:

1) Enable a log event source in the connection settings of some AS server Resource - easiest is to enabled rhq-server.log event source for the RHQ Server resource. Save the conn settings.

2) Stop the Agent on the same box as the AS server above, then restart the Agent with the -t option (which disables SIGAR).

3) Verify that within a few minutes the Agent logs a warning similar to this:

2012-01-31 12:07:11,193 WARN  [ResourceContainer.invoker.daemon-1] (core.pluginapi.event.log.LogFileEventResourceComponentHelper)- Log files [/home/ips/Projects/rhq/dev-container/logs/rhq-server-log4j.log] for [JBossAS:JBossAS Server] Resource with key [/home/ips/Projects/rhq/dev-container/jbossas/server/default] cannot be polled, because log file polling requires RHQ native support, which has been disabled for this Agent.

Also verify that there are no errors in the Agent log file related to log file event polling.
Comment 8 Simeon Pinder 2012-02-02 22:19:44 EST
Moving to ON_QA as there is a new binary 3.0.1.GA RC2 available here to test with:
https://brewweb.devel.redhat.com//buildinfo?buildID=197202
Comment 9 Mike Foley 2012-02-03 16:01:37 EST
attaching agent log to document my verification.  my observations:

1) line #1 shows the agent started with -t ... no native libraries

2) over the course of 6 minutes ... i do not see the WARN message as expected in step#3 of the verification process.

this doesn't seem to be the expected behavior in RC2.
Comment 10 Mike Foley 2012-02-03 16:02:38 EST
Created attachment 559365 [details]
agent log ... (which does not show the WARN as expected)

the 1st line of the agent file confirms the agent restart with -2

but i don't see the expected WARN statement.
Comment 11 Ian Springer 2012-02-13 23:12:57 EST
I just verified this using the recent build of RHQ 3.0.1 running on an internal Beaker box. After enabling log events on my RHQ Server Resource and restarting the Agent with -t, I saw the following message in the Agent log:

2012-02-13 23:09:13,419 WARN  [ResourceContainer.invoker.daemon-1] (core.pluginapi.event.log.LogFileEventResourceComponentHelper)- Log files [/usr/share/jboss-on-3.0.1.GA/server/logs/rhq-server-log4j.log] for [JBossAS:JBossAS Server] Resource with key [/usr/share/jboss-on-3.0.1.GA/server/jbossas/server/default] cannot be polled, because log file polling requires RHQ native support, which has been disabled for this Agent.

Mike, perhaps you forgot to do step 1) from the test steps I provided in comment 7?
Comment 12 Sunil Kondkar 2012-02-14 02:29:05 EST
Verified on Version: 3.0.1.GA RC4 (Build Number: dd8a001:c5270fb)

Enabled event log RHQ Server Resource and confirmed that events are logged in 'Events->History' tab of the resource. Restarted the agent with -t option. After few minutes, the agent log displays below:

2012-02-14 12:36:55,786 WARN  [ResourceContainer.invoker.daemon-1] (core.pluginapi.event.log.LogFileEventResourceComponentHelper)- Log files [/install/jonbuilds/jon301garc4/jon-server-3.0.1.GA/logs/rhq-server-log4j.log] for [JBossAS:JBossAS Server] Resource with key [/install/jonbuilds/jon301garc4/jon-server-3.0.1.GA/jbossas/server/default] cannot be polled, because log file polling requires RHQ native support, which has been disabled for this Agent.

There are no errors related to log file event polling.
Comment 14 Heiko W. Rupp 2013-09-03 11:19:10 EDT
Bulk closing of old issues in VERIFIED state.